﻿using Borepin.Model;
using Borepin.Service.ServerInstances;
using Prism.Mvvm;
using Prism.Navigation;
using System.Collections.ObjectModel;
using System.Threading.Tasks;

namespace Borepin.PageModel
{
    public class ServerInstancesPageModel : BindableBase
    {
        private INavigationService _NavigationService;
        private IBFFHInstanceService _BFFHInstanceService;

        public ServerInstancesPageModel(INavigationService navigationService, IBFFHInstanceService bffhInstanceService)
        {
            _NavigationService = navigationService;
            _BFFHInstanceService = bffhInstanceService;

            LoadData();
        }

        private async Task LoadData()
        {
            _ServerInstance_List = new ObservableCollection<BFFHInstance>(await _BFFHInstanceService.GetBFFHInstances());
        }

        private ObservableCollection<BFFHInstance> _ServerInstance_List;
        public ObservableCollection<BFFHInstance> ServerInstance_List
        {
            get => _ServerInstance_List;
            set => SetProperty(ref _ServerInstance_List, value);
        }
    }
}
